pub fn part_one(input_lines: Vec<String>) -> String {
    let vert_dim = input_lines.len();
    let horz_dim = input_lines[0].len();

    let mut matrix = vec![vec![false; horz_dim]; vert_dim];

    for (y, line) in input_lines.iter().enumerate() {
        for (x, c) in line.chars().enumerate() {
            matrix[x][y] = c == '#';
        }
    }

    println!("Pre-expand dims: {:?}, {:?}", matrix.len(), matrix[0].len());

    expand_rows(&mut matrix);
    expand_cols(&mut matrix);

    println!("Post-expand dims: {:?}, {:?}", matrix.len(), matrix[0].len());

    String::from("Not implemented")
}

fn expand_rows(matrix: &mut Vec<Vec<bool>>) {
    let mut i = 0;
    while i < matrix.len() {
        let row = matrix[i].clone();
        if all_false(&row) {
            matrix.insert(i, row.clone());
            i += 1;
        }
        i += 1;
    }
}

fn expand_cols(matrix: &mut Vec<Vec<bool>>) {
    let mut i = 0;
    while i < matrix[0].len() {
        let col = matrix.iter().map(|row| row[i]).collect::<Vec<bool>>();
        if all_false(&col) {
            for row in matrix.iter_mut() {
                row.insert(i, false);
            }
            i += 1;
        }
        i += 1;
    }
}

fn all_false(vector: &Vec<bool>) -> bool {
    vector.iter().all(|x| *x == false)
}